<template>

    <div class="card card-primary card-outline">
        <div class="home col-8 mx-auto center-align">
            <h3>Rating of the best movies</h3>
        </div>
        <div class="card-body box-profile mx-3">
            <ul class="list-group list-group-unbordered mb-3 mx-2 container">
                <li class="list-group-item row" v-for="(filmData, index) in filmsData" :key="index">
                    <div class="col-2">
                        <a :href="filmData.url"><img :src="filmData.img_src" :alt="filmData.name"></a>
                    </div>
                    <div class="col text text-film-title">
                        {{ filmData.id }}.
                        <div class="text text-film-title">
                            <a :href="filmData.url" class="film-link">{{ filmData.name }}</a>
                        </div>
                        <div class="text text-film-description">
                            {{ filmData.release_date }}
                        </div>
                        <div class="text text-film-title">
                            Score: {{ filmData.score }}
                        </div>
                        <div class="text text-film-description">
                            {{ filmData.description }}
                        </div>
                    </div>
                </li>
            </ul>
        </div>
    </div>

</template>

<script>
import eventHub from '../eventHub';
import router from '../router';
import Film from "../src/apis/Film";

export default {
    name: 'home',
    data() {
        return {
            user: null,
            filmsData: null,
        }
    },
    mounted() {
        // adding eventHub listener
        eventHub.$on('app-home', (data) => {
            this.user = data;
            this.checkAuthUser();
        })

    },
    updated() {

    },
    beforeDestroy() {
        // removing eventHub listener
        eventHub.$off('app-home');
    },
    watch: {
        /*user: {
            handler: 'checkAuthUser',
            immediate: true
        }*/
        /*$route() {
            this.checkAuthUser();
        }*/
    },
    methods: {
        checkAuthUser() {
            if (!this.user) {
                router.push('/guest');
            }
            this.getFilmsData();
        },
        getFilmsData() {
            Film.getFilmsData().then(response => {
                this.filmsData = response.data.films;
            })
        },
    },
}

</script>

<style scoped>

h2 {
    color: orange;
}

.center-align {
    text-align: center;
}

.card, .card-body, .list-group, .list-group-item {
    background-color: black;
    border-color: orange;
    color: orange;
}

.text {
    color: orange;
}

.text-film-title {
    font-family: Helvetica, Arial, fantasy;
    font-size: 18px;
}

.text-film-description {
    font-family: Helvetica, Arial, sans-serif;
    font-size: 14px;
}

.card {
    border: none;
}

.film-link {
    color: crimson;
        display: inline-block;
}
.film-link:hover{
    color: orange;
}

.row {
    display: flex;
}

.images::before{
    content: "";
    display: block;
}

</style>
